#include <stdlib.h>	/* for snprintf */
#include "include/ncurslib.h"

extern int scrW;
extern int scrH;
extern int score;

int color = 0;

void initNcurse(void){
	initscr();      /* ncurses won't do anything without this */
	nonl();         /* Allows detection of return key; Not needed here */
	noecho();       /* Don't print what you type back on the screen */
	keypad(stdscr,TRUE);    /* Allow input from arrow keys */
	cbreak();               /* Don't wait for newline on getch() input */
	nodelay(stdscr,1);      /* Don't sleep for getch() input */
	/*	getmaxyx(stdscr, scrH, scrW);	*/

	if(has_colors() == FALSE){
		color = 0;
	} else {
		color = 1;
		start_color();  /* Start color */
        	init_pair(1, COLOR_RED, COLOR_BLACK);
		init_pair(2, COLOR_GREEN, COLOR_BLACK);
		init_pair(3, COLOR_YELLOW, COLOR_BLACK);
		init_pair(4, COLOR_BLUE, COLOR_BLACK);
		init_pair(5, COLOR_MAGENTA, COLOR_BLACK);
		init_pair(6, COLOR_CYAN, COLOR_BLACK);
		init_pair(7, COLOR_WHITE, COLOR_BLACK);
		init_pair(8, COLOR_BLACK, COLOR_GREEN);
        	init_pair(9, COLOR_BLACK, COLOR_RED);
        	init_pair(10, COLOR_BLACK, COLOR_BLUE);
		init_pair(11, COLOR_BLACK, COLOR_YELLOW);
	}
	/* Debugging:
	printf("Screen Height: %d , Screen Width: %d\n", scrH, scrW);
	*/
}


/* drawBorder(): Make a pretty border around the gameplay area */
void drawBorder(void){
	int i=0, j=0;	/* Loop counters */

	if(color) attron(COLOR_PAIR(1));
	
	/* mvaddch() counts from 1, not 0 */
	while(i<scrW+1) mvaddch(j,++i,'#');
	while(j<scrH+1) mvaddch(++j,i,'#');
	while(i>0) mvaddch(j,--i,'#');
	while(j>0) mvaddch(--j,i,'#');
	
	if(color) attroff(COLOR_PAIR(1));
}

/* printScore: prints your score */
void printScore(void){
	char	  s[]="         ",	/* Blank area */
	txt[]="Score:";			/* The word "Score:" */
	int i=0;
	/* Blank out score printing area */
	for(i=0; i<10 && s[i]!='\0'; i++){
		mvaddch(scrH+2, scrW/2 + 7+i, s[i]);
	}
	/* Convert score to character string */
	snprintf(s,10,"%d",score);
	/* Print "Score:" and score */
	for(i=0; i<6; i++){
		mvaddch(scrH + 2, scrW/2 + i, txt[i]);
	}
	for(i=0; i<10 && s[i]!='\0' ;i++){
		mvaddch(scrH + 2, scrW/2 + 7+i, s[i]);
	}
}
